local mod = ...



-- Default Balancing (event list) ---------------------------------------------------------------------------------------------

mod:override({
    Id = "DEFAULT_BALANCING",
    EventList = {
        Action = "APPEND",
        "EVENT_FESTIVAL_SUMMER_SETUP",
    }
})



-- Event: Summer Setup ---------------------------------------------------------------------------------------------
mod:register({
	DataType = "EVENT",
    Id = "EVENT_FESTIVAL_SUMMER_SETUP",
    IsInMainPool = false, -- the main pool seems to suppress itself until the first Weather event fires, so custom events should be outside the main pool
    IsRecurrent = false,
    DaysToFirst = 1, 
	ConditionList = {
	},
	ActionList = {
        {
            DataType = "EVENT_ACTION_GIVE_REWARD",
			OnClickCallback = {
				DataType = "EVENT_CALLBACK_TRIGGER_EVENT",
				Event = "EVENT_FESTIVAL_SUMMER_PRE",
				Delay = 98 * 60
			},
            QuestRewardList = {
            }
        },
    }
})



-- Event: Festival Pre-Notification ---------------------------------------------------------------------------------------------
mod:registerAssetId("models/Textures/SummerFestival.png", "TEXTURE_FESTIVAL_SUMMER")

mod:register({
	DataType = "EVENT",
    Id = "EVENT_FESTIVAL_SUMMER_PRE",
    IsInMainPool = false, -- the main pool seems to suppress itself until the first Weather event fires, so custom events should be outside the main pool
    IsRecurrent = false,
	ActionList = {
        -- {
        --     DataType = "ACTION_SHOW_NARRATIVE_PANEL",
        --     NarrativePanelData = {
        --         DataType = "DATA_NARRATIVE_PANEL",
        --         Title = "EVENT_FESTIVAL_SUMMER_PRE_TITLE",
        --         Description = "EVENT_FESTIVAL_SUMMMER_PRE_DESC",
        --         PanelVisual = "TEXTURE_FESTIVAL_SUMMER"
        --     },
        --     ChoiceList = {
        --         {
        --             DataType = "EVENT_CHOICE",
        --             ShortName = "EVENT_FESTIVAL_OK",
        --             EventActionList = {
        --                 {
        --                     DataType = "EVENT_ACTION_IGNORE"
        --                 },
        --             },
        --             OnClickCallbackList = nil
        --         },
        --     },
        --     OnClickCallback = nil
        -- },
        -- {
        --     DataType = "EVENT_ACTION_GIVE_REWARD",
        --     OnClickCallback = {
        --         DataType = "EVENT_CALLBACK_TRIGGER_EVENT",
        --         Event = "EVENT_FESTIVAL_WINTER_START",
        --         Delay = 14 * 60
        --     },
        --     QuestRewardList = {
        --         {
        --             DataType = "QUEST_REWARD_GAME_RULE",
        --             RuleModifier = {
        --                 DataType = "GAME_RULE_MODIFIER_CROP_YIELDS",
        --                 ResourceList = {
        --                     "RESOURCE_SECURITY",
        --                 },
        --                 YieldPercentage = 2.0,
        --                 IsUntilRemoval = false,
        --                 IsGlobal = true,
        --                 DurationInDays = 13
        --             },
        --             OptionalApplicator = "EVENT_FESTIVAL_WINTER_PRE"                
        --         },
        --     },
        -- },
    }
})



-- Event: Summer Festival Start ----------------------------------------------------------------------------
mod:register({
	DataType = "EVENT",
    Id = "EVENT_FESTIVAL_SUMMER_START",
    IsInMainPool = false, -- the main pool seems to suppress itself until the first Weather event fires, so custom events should be outside the main pool
    IsRecurrent = true,
	ActionList = {
        -- {
        --     DataType = "ACTION_SHOW_NARRATIVE_PANEL",
        --     NarrativePanelData = {
        --         DataType = "DATA_NARRATIVE_PANEL",
        --         Title = "EVENT_FESTIVAL_WINTER_START_TITLE",
        --         Description = "EVENT_FESTIVAL_WINTER_START_DESC",
        --         PanelVisual = "TEXTURE_FESTIVAL_WINTER"
        --     },
        --     ChoiceList = {
        --         {
        --             DataType = "EVENT_CHOICE",
        --             ShortName = "EVENT_FESTIVAL_OK",
        --             EventActionList = {
        --                 {
        --                     DataType = "EVENT_ACTION_IGNORE"
        --                 },
        --             },
        --             OnClickCallbackList = nil
        --         },
        --     },
        --     OnClickCallback = nil
        -- },
        -- {
        --     DataType = "EVENT_ACTION_GIVE_REWARD",
        --     OnClickCallback = {
        --         DataType = "EVENT_CALLBACK_TRIGGER_EVENT",
        --         Event = "EVENT_FESTIVAL_WINTER_END",
        --         Delay = 28 * 60
        --     },
        --     QuestRewardList = {
        --         {
        --             DataType = "QUEST_REWARD_GAME_RULE",
        --             RuleModifier = {
        --                 DataType = "GAME_RULE_MODIFIER_NEED_TYPE_DEPLETE_RATE",
        --                 NeedType = "NEED_PRIMARY_NEED",
        --                 BonusInPerc = 4.5,
        --                 IsUntilRemoval = false,
        --                 IsGlobal = true,
        --                 DurationInDays = 27
        --             },
        --             OptionalApplicator = "EVENT_FESTIVAL_WINTER_START"
        --         },
        --         {
        --             DataType = "QUEST_REWARD_GAME_RULE",
        --             RuleModifier = {
        --                 DataType = "GAME_RULE_MODIFIER_NEED_TYPE_DEPLETE_RATE",
        --                 NeedType = "NEED_FOOD",
        --                 BonusInPerc = 4.5,
        --                 IsUntilRemoval = false,
        --                 IsGlobal = true,
        --                 DurationInDays = 27
        --             },
        --             OptionalApplicator = "EVENT_FESTIVAL_WINTER_START"
        --         },
        --         {
        --             DataType = "QUEST_REWARD_GAME_RULE",
        --             RuleModifier = {
        --                 DataType = "GAME_RULE_MODIFIER_NEED_TYPE_DEPLETE_RATE",
        --                 NeedType = "NEED_GOODS",
        --                 BonusInPerc = 4.5,
        --                 IsUntilRemoval = false,
        --                 IsGlobal = true,
        --                 DurationInDays = 27
        --             },
        --             OptionalApplicator = "EVENT_FESTIVAL_WINTER_START"
        --         },
        --         {
        --             DataType = "QUEST_REWARD_GAME_RULE",
        --             RuleModifier = {
        --                 DataType = "GAME_RULE_MODIFIER_NEED_TYPE_DEPLETE_RATE",
        --                 NeedType = "NEED_LUXURY",
        --                 BonusInPerc = 4.5,
        --                 IsUntilRemoval = false,
        --                 IsGlobal = true,
        --                 DurationInDays = 27
        --             },
        --             OptionalApplicator = "EVENT_FESTIVAL_WINTER_START"
        --         },
        --         {
        --             DataType = "QUEST_REWARD_GAME_RULE",
        --             RuleModifier = {
        --                 DataType = "GAME_RULE_MODIFIER_NEED_TYPE_DEPLETE_RATE",
        --                 NeedType = "NEED_ENTERTAINMENT",
        --                 BonusInPerc = 4.5,
        --                 IsUntilRemoval = false,
        --                 IsGlobal = true,
        --                 DurationInDays = 27
        --             },
        --             OptionalApplicator = "EVENT_FESTIVAL_WINTER_START"
        --         },
        --         {
        --             DataType = "QUEST_REWARD_GAME_RULE",
        --             RuleModifier = {
        --                 DataType = "GAME_RULE_MODIFIER_NEED_TYPE_DEPLETE_RATE",
        --                 NeedType = "NEED_SECURITY",
        --                 BonusInPerc = 4.5,
        --                 IsUntilRemoval = false,
        --                 IsGlobal = true,
        --                 DurationInDays = 27
        --             },
        --             OptionalApplicator = "EVENT_FESTIVAL_WINTER_START"
        --         },
        --     }
        -- },    
    }
})



-- Event: Summer Festival End ----------------------------------------------------------------------------
mod:register({
	DataType = "EVENT",
    Id = "EVENT_FESTIVAL_SUMMER_END",
    IsInMainPool = false, -- the main pool seems to suppress itself until the first Weather event fires, so custom events should be outside the main pool
    IsRecurrent = true,
    DaysToFirst = 1, --309, -- 1st day of Month 11 Week 2 Day 1
    Delay = 30, -- seconds after the start of the day
	ConditionList = nil,
	ActionList = {
        -- {
        --     DataType = "ACTION_SHOW_NARRATIVE_PANEL",
        --     NarrativePanelData = {
        --         DataType = "DATA_NARRATIVE_PANEL",
        --         Title = "EVENT_FESTIVAL_WINTER_END_TITLE",
        --         Description = "EVENT_FESTIVAL_WINTER_END_DESC",
        --         PanelVisual = "TEXTURE_FESTIVAL_WINTER"
        --     },
        --     ChoiceList = {
        --         {
        --             DataType = "EVENT_CHOICE",
        --             ShortName = "EVENT_FESTIVAL_OK",
        --             EventActionList = {
        --                 {
        --                     DataType = "EVENT_ACTION_IGNORE"
        --                 },
        --             },
        --             OnClickCallbackList = nil
        --         },
        --     },
        --     OnClickCallback = nil
        -- },
        -- {
        --     DataType = "EVENT_ACTION_GIVE_REWARD",
        --     OnClickCallback = {
        --         DataType = "EVENT_CALLBACK_TRIGGER_EVENT",
        --         Event = "EVENT_FESTIVAL_WINTER_PRE",
        --         Delay = (28 + 266) * 60
        --     },
        --     QuestRewardList = {
        --     }
        -- }, 
    }
})



